<script lang="ts">
    import { createEventDispatcher, onMount } from 'svelte';
    import Querier from './querier.svelte';
    import Adminer from './settings/adminer.svelte';
    import PhpMyAdmin511 from './settings/phpmyadmin511.svelte';
    import type { ServerModel } from '../app/domain/models/server.model';
    import { QuerierModel } from '../app/domain/models/querier.model';
    import useCases from '../app/use-cases';
    import type { SvelteComponentTyped } from 'svelte/internal';
    import type { AdapterSettings } from '../app/domain/types/adapter.type';

    export let server: ServerModel;

    let connected: boolean = false;
    let activeQuerier: QuerierModel = server.getActiveQuerier();
    const queriers: Record<QuerierModel, { focusEditor: () => void }> = {};
    let serverQueriers: QuerierModel[] = server.getQueriers();
    let availableDatabases: string[] = [];
    let currentDatabase: string;

    let adapterSettings: SvelteComponentTyped<{settings: AdapterSettings}>;

    const dispatch = createEventDispatcher();


    switch (server.db.adapter) {
        case 'adminer':
            adapterSettings = Adminer;
            break;
        case 'phpmyadmin511':
            adapterSettings = PhpMyAdmin511;
            break;
    }


    onMount(async () => {
        connected = await useCases.dbConnectUc.execute(server);
        availableDatabases = await useCases.dbFetchDatabasesUc.execute(server);
        currentDatabase = server.activeDatabase || '';
    });

    async function login() {
        dispatch('save');
        await useCases.dbConnectUc.execute(server);
        connected = await useCases.dbConnectUc.execute(server);
    }

    function createPane() {
        activeQuerier = useCases.createQuerierUc.execute(server);
        serverQueriers = server.getQueriers();
        dispatch('save');
    }

    function selectPane(querier?: QuerierModel) {
        server.setActiveQuerier(querier);
        activeQuerier = querier;
        if (activeQuerier) {
            setTimeout(() => {
                queriers[activeQuerier].focusEditor();
            }, 200);
        }
        dispatch('save');
    }

    async function onDatabaseChange({ target }: { target: HTMLInputElement }) {
        await useCases.dbUseDatabaseUc.execute(server, target.value);
        dispatch('save');
    }

    function deletePane(querier: QuerierModel) {
        if (activeQuerier === querier) {
            activeQuerier = undefined;
        }
        server.removeQuerier(querier);
        server.setActiveQuerier(undefined);
        serverQueriers = server.getQueriers();
        dispatch('save');
    }
</script>

<div class="container">
    <div class="tabs is-small">
        <ul>
            <li class:is-active={!serverQueriers.includes(activeQuerier)} on:click={() => selectPane(undefined)}>
                <a>
                    <span>Settings</span>
                    <span class="icon"><i class="fas fa-gear" aria-hidden="true"></i></span>
                </a>
            </li>
            {#each serverQueriers as querier}
            <li class:is-active={querier === activeQuerier}>
                <a>
                    <span on:click={() => selectPane(querier)}>{querier.name}</span>
                    <span class="icon" on:click={() => deletePane(querier)}><i class="fas fa-close" aria-hidden="true"></i></span>
                </a>
            </li>
            {/each}
            <li on:click={createPane}><a><span></span><span><span class="icon"><i class="fas fa-plus" aria-hidden="true"></i></span></span></a></li>
        </ul>
    </div>

    <p>Connected: {connected ? 'yes' : 'no' }, DB: {server.activeDatabase}</p>
    <p>
        Active Database:
        <select class="select" value={currentDatabase} on:change={onDatabaseChange}>
            <option value="" selected={!currentDatabase}>Select DB</option>
            {#each availableDatabases as db}
                <option value={db} selected={db === currentDatabase}>{db}</option>
            {/each}
        </select>
    </p>

    {#each serverQueriers as querier}
        <div hidden={querier !== activeQuerier}>
            <Querier bind:actions={queriers[querier]} bind:querier={querier} server={server} on:save={() => dispatch('save')}></Querier>
        </div>
    {/each}
    {#if !activeQuerier }
    <div hidden={0 && activeQuerier}>
        <form>
            <div class="field is-horizontal">
                <div class="field-label is-normal">
                    <label class="label">Name</label>
                </div>
                <div class="field-body">
                    <div class="field">
                        <div class="control">
                            <input class="input is-danger" type="text" placeholder="e.g. TestBed" bind:value={server.name}>
                        </div>
                        <p class="help is-danger">
                            This field is required
                        </p>
                    </div>
                </div>
            </div>

            <svelte:component this={adapterSettings} settings={server.db}/>

            <div class="field is-horizontal">
                <div class="field-label">
                    <!-- Left empty for spacing -->
                </div>
                <div class="field-body">
                    <div class="field">
                        <div class="control">
                            <button type="button" class="button is-primary" on:click={login}>
                                Login
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </form>
    </div>
    {/if}
</div>
